/*
 * Copyright 2017 Red Hat, Inc. and/or its affiliates.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.kie.api.internal.utils;

import java.util.Hashtable;

import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceRegistration;

public class Activator implements BundleActivator {

    private ServiceRegistration discoveryReg;

    @Override
    public void start( BundleContext context ) throws Exception {
        this.discoveryReg = context.registerService( new String[]{ ServiceDiscoveryImpl.class.getName() },
                                                     ServiceDiscoveryImpl.getInstance(),
                                                     new Hashtable() );
    }

    @Override
    public void stop( BundleContext context ) throws Exception {
        this.discoveryReg.unregister();
    }
}
